// PocketIrked2View.cpp : implementation of the CPocketIrked2View class
//

#include "stdafx.h"
#include "PocketIrked2.h"

#include "PocketIrked2Doc.h"
#include "PocketIrked2View.h"
#include "LevelPacksDlg.h"
#include "HowToPlayDlg.h"
#include "Preferences.h"
#include "BlockRemainingDlg.h"
#include "LookupDlg.h"
#include "AreYouSureDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPocketIrked2View

IMPLEMENT_DYNCREATE(CPocketIrked2View, CView)

BEGIN_MESSAGE_MAP(CPocketIrked2View, CView)
	//{{AFX_MSG_MAP(CPocketIrked2View)
	ON_COMMAND(ID_BACK, OnBack)
	ON_COMMAND(ID_FIRST, OnFirst)
	ON_COMMAND(ID_GAME_ABOUT, OnGameAbout)
	ON_COMMAND(ID_GAME_HOWTOPLAY, OnGameHowtoplay)
	ON_COMMAND(ID_GAME_MEMORY, OnGameMemory)
	ON_COMMAND(ID_GAME_PREFERENCES, OnGamePreferences)
	ON_COMMAND(ID_GAME_RECALL, OnGameRecall)
	ON_COMMAND(ID_GAME_REPLAYCURRENTLEVEL, OnGameReplaycurrentlevel)
	ON_COMMAND(ID_GAME_UNDO, OnGameUndo)
	ON_COMMAND(ID_LAST, OnLast)
	ON_COMMAND(ID_LEVEL_BLOCKSREMAINING, OnLevelBlocksremaining)
	ON_COMMAND(ID_LEVEL_CLEARSOLVEDLEVELS, OnLevelClearsolvedlevels)
	ON_COMMAND(ID_LEVEL_FIRST, OnLevelFirst)
	ON_COMMAND(ID_LEVEL_LAST, OnLevelLast)
	ON_COMMAND(ID_LEVEL_LEVELPACKS, OnLevelLevelpacks)
	ON_COMMAND(ID_LEVEL_LOOKUP, OnLevelLookup)
	ON_COMMAND(ID_LEVEL_NEXT, OnLevelNext)
	ON_COMMAND(ID_LEVEL_PREVIOUS, OnLevelPrevious)
	ON_COMMAND(ID_LEVEL_SHOWSOLUTION, OnLevelShowsolution)
	ON_COMMAND(ID_LOOKUP, OnLookup)
	ON_COMMAND(ID_MEM, OnMem)
	ON_COMMAND(ID_NEXT, OnNext)
	ON_COMMAND(ID_RECALL, OnRecall)
	ON_COMMAND(ID_RESTART, OnRestart)
	ON_COMMAND(ID_UNDO, OnUndo)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_UPDATE_COMMAND_UI(ID_GAME_UNDO, OnUpdateGameUndo)
	ON_UPDATE_COMMAND_UI(ID_GAME_MEMORY, OnUpdateGameMemory)
	ON_UPDATE_COMMAND_UI(ID_GAME_RECALL, OnUpdateGameRecall)
	ON_UPDATE_COMMAND_UI(ID_LEVEL_FIRST, OnUpdateLevelFirst)
	ON_UPDATE_COMMAND_UI(ID_LEVEL_LAST, OnUpdateLevelLast)
	ON_UPDATE_COMMAND_UI(ID_LEVEL_NEXT, OnUpdateLevelNext)
	ON_UPDATE_COMMAND_UI(ID_LEVEL_PREVIOUS, OnUpdateLevelPrevious)
	ON_UPDATE_COMMAND_UI(ID_LEVEL_SHOWSOLUTION, OnUpdateLevelShowsolution)
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPocketIrked2View construction/destruction


CPocketIrked2View::CPocketIrked2View()
{
	// TODO: add construction code here
	m_bInit = FALSE;
}

CPocketIrked2View::~CPocketIrked2View()
{
	int i,j;

	for(i=0;i<10;i++)
		for(j=0;j<8;j++)
			m_sBricks[i][j].SetBitmap(NULL); // unselect all brick bitmaps from bricks

	for(i=0;i<10;i++)
	{
		m_bmpBricks[i].DeleteObject(); // delete the brick bitmaps
	}
}

BOOL CPocketIrked2View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CPocketIrked2View drawing

void CPocketIrked2View::OnDraw(CDC* pDC)
{
	CRect rc;
	GetClientRect(rc);

	CBrush br(RGB(250,250,250));
	CPocketIrked2Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CBrush BkBrush;
	CDC * pTempDC = new CDC();
	pTempDC ->CreateCompatibleDC(pDC);
	CBitmap bmp;
	CBitmap* pOldBmp;
	bmp.CreateCompatibleBitmap(pDC,rc.Width(),rc.Height());
	pOldBmp = pTempDC -> SelectObject(&bmp);

	pTempDC->FillRect(rc,&br);

	DrawBricks(pTempDC);

	pDC -> BitBlt(rc.left,rc.top,rc.right,rc.bottom,pTempDC,0,0,SRCCOPY);
	pTempDC -> SelectObject(pOldBmp);
	delete pTempDC;

}

/////////////////////////////////////////////////////////////////////////////
// CPocketIrked2View diagnostics

#ifdef _DEBUG
void CPocketIrked2View::AssertValid() const
{
	CView::AssertValid();
}

void CPocketIrked2View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CPocketIrked2Doc* CPocketIrked2View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPocketIrked2Doc)));
	return (CPocketIrked2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPocketIrked2View message handlers

void CPocketIrked2View::OnInitialUpdate() 
{
	CPocketIrked2Doc *pDoc = GetDocument();
	static bCalled = FALSE;
	if(bCalled)
		return;

	bCalled=TRUE;

	
	int i,j;
	
	m_bmpBricks[0].LoadBitmap(IDB_BLANK);

	HDC hDC=::GetDC(NULL);
	BOOL bColor=::GetDeviceCaps(hDC,BITSPIXEL)<8?0:1;
	::ReleaseDC(NULL,hDC);

	if(1000 == pDoc->m_iTileset)
	{	
		pDoc->m_iTileset = 1000+(bColor*100);
	}

	for(i=1;i<10;i++)
		m_bmpBricks[i].LoadBitmap(i+pDoc->m_iTileset); // loads the initial set

/*	for(i=0;i<10;i++)
		for(j=0;j<8;j++)
		{
			m_sBricks[i][j].Create(NULL, WS_VISIBLE|WS_CHILD|SS_BITMAP, CRect(0,0,16,16),this,1000+(10*i)+j); // create the blocks
			m_sBricks[i][j].MoveWindow(16+(i*16),16+(j*16),16,16);   // move them into place
		}
*/
	for(i=0;i<10;i++)
	{
		for(j=0;j<8;j++)
		{
			m_sBricks[i][j].m_pt.x = 16+(i*16),
			m_sBricks[i][j].m_pt.y = 16+(j*16);   // move them into place
		}
	}
	m_bInit = TRUE;
	Invalidate();
	UpdateWindow();

//	CDC* pDC;
	m_sAuthor.Create(TEXT("Author"),SS_LEFTNOWORDWRAP|WS_VISIBLE|WS_CHILD,CRect(16,160,224,180),this,2000);

	m_sURL.Create(TEXT("URL"),SS_LEFTNOWORDWRAP|WS_VISIBLE|WS_CHILD,CRect(16,180,224,200),this,2001);

	m_sDescription.Create(TEXT("Description"),SS_LEFT|WS_VISIBLE|WS_CHILD,CRect(16,200,224,240),this,2002);

	m_tbSecondBar.Create(CCS_BOTTOM|WS_VISIBLE|WS_CHILD|WS_BORDER, CRect(0,250,240,274),this,4000);

	TBBUTTON tbb[]=
	{
					{4,ID_LEVEL_FIRST,TBSTATE_ENABLED,TBSTYLE_BUTTON|WS_BORDER,NULL,-1},
					{5,ID_LEVEL_PREVIOUS,TBSTATE_ENABLED,TBSTYLE_BUTTON|WS_BORDER,NULL,-1},
					{6,ID_LEVEL_LOOKUP,TBSTATE_ENABLED,TBSTYLE_BUTTON|WS_BORDER,NULL,-1},
					{7,ID_LEVEL_NEXT,TBSTATE_ENABLED,TBSTYLE_BUTTON|WS_BORDER,NULL,-1},
					{8,ID_LEVEL_LAST,TBSTATE_ENABLED,TBSTYLE_BUTTON|WS_BORDER,NULL,-1},
					{-1,TBSTYLE_SEP,NULL,-1},
					{0,ID_GAME_REPLAYCURRENTLEVEL,TBSTATE_ENABLED,TBSTYLE_BUTTON|WS_BORDER,NULL,-1},
					{-1,TBSTYLE_SEP,NULL,-1},
					{1,ID_GAME_UNDO,TBSTATE_INDETERMINATE,TBSTYLE_BUTTON|WS_BORDER,NULL,-1},
					{2,ID_GAME_RECALL,TBSTATE_INDETERMINATE,TBSTYLE_BUTTON|WS_BORDER,NULL,-1},
					{3,ID_GAME_MEMORY,TBSTATE_ENABLED,TBSTYLE_BUTTON|WS_BORDER,NULL,-1},
	};
	m_tbSecondBar.AddBitmap(1,IDB_RESET);
	m_tbSecondBar.AddBitmap(1,IDB_UNDO);
	m_tbSecondBar.AddBitmap(1,IDB_RECALL);
	m_tbSecondBar.AddBitmap(1,IDB_MEMORY);
	m_tbSecondBar.AddBitmap(1,IDB_FIRST);
	m_tbSecondBar.AddBitmap(1,IDB_BACK);
	m_tbSecondBar.AddBitmap(1,IDB_LOOKUP);
	m_tbSecondBar.AddBitmap(1,IDB_NEXT);
	m_tbSecondBar.AddBitmap(1,IDB_LAST);
	m_tbSecondBar.AddButtons(11,tbb);

	m_iMoves=0;

	if(pDoc->m_iCurrentLevel == pDoc->m_iMaxLevel)
	{
		m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_INDETERMINATE);
		m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_INDETERMINATE);
	}
	else
	{
		m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_ENABLED);
		m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_ENABLED);
	}
	if(!pDoc->m_iCurrentLevel)
	{
		m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_INDETERMINATE);
		m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_INDETERMINATE);
	}
	else
	{
		m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_ENABLED);
		m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_ENABLED);
	}

	CView::OnInitialUpdate();
}

void CPocketIrked2View::OnUpdate(CView* pSender, LPARAM lHint, CObject* ) 
{
	OnInitialUpdate();
	CPocketIrked2Doc* pDoc=GetDocument();
	int i,j;
	m_iCount=0;
	for(i=0;i<10;i++)
	{
		for(j=0;j<8;j++)
		{	
			//m_sBricks[i][j].SetBitmap(m_bmpBricks[pDoc->m_lPlayGround.m_lBits[j][i]]);
			m_sBricks[i][j].SetBitmap(pDoc->m_lPlayGround.m_lBits[j][i]);
			if(pDoc->m_lPlayGround.m_lBits[j][i] && pDoc->m_lPlayGround.m_lBits[j][i] < 9 )
				m_iCount++;
		}
	}

	CString str;

	//m_sAuthor.SetWindowText(pDoc->m_strAuthor);
	str.Format(_T("Par: %d   Score: %d"),strlen((char*)(pDoc->m_lPlayGround.m_btSolution))/2, pDoc->m_iLevelScore);
	m_sAuthor.SetWindowText(str);
	//m_sURL.SetWindowText(pDoc->m_strURL);
	str.Format(_T("Moves: %d"),m_iMoves);
	m_sURL.SetWindowText(str);
	m_sDescription.SetWindowText(pDoc->m_strDescription);

	if(AfxGetApp()->m_pMainWnd)
	{
				CString strTitle;
				strTitle.Format(_T("%d: %s"),pDoc->m_iCurrentLevel,pDoc->m_lPlayGround.m_strTitle);
				AfxGetApp()->m_pMainWnd->SetWindowText(strTitle);
	}


	Invalidate();
	UpdateWindow();
	UpdateData(FALSE);
}

void CPocketIrked2View::OnGameAbout() 
{
	CAboutDlg AboutDlg;

	AboutDlg.DoModal();	
}

void CPocketIrked2View::OnGameHowtoplay() 
{
	CHowToPlayDlg HowToPlayDlg;
	
	HowToPlayDlg.DoModal();
}

void CPocketIrked2View::OnMem() 
{
	OnGameMemory();
}

void CPocketIrked2View::OnGameMemory() 
{
	CPocketIrked2Doc *pDoc=GetDocument();

	pDoc->Memorize();
	
	m_tbSecondBar.SetState(ID_GAME_RECALL,TBSTATE_ENABLED);
	//OnUpdate(0,0,0);

}

void CPocketIrked2View::OnGamePreferences() 
{
	CPreferences PreferecesDlg;
	CPocketIrked2App *pApp =(CPocketIrked2App *)AfxGetApp();
	int i;
	
	PreferecesDlg.DoModal();

	for(i=1;i<10;i++)
	{
		m_bmpBricks[i].DeleteObject();
		m_bmpBricks[i].LoadBitmap(PreferecesDlg.m_iTileSet+i); // loads the newl set
	}
	pApp->WriteProfileInt(_T("global"),_T("tileset"),PreferecesDlg.m_iTileSet);
	OnUpdate(0,0,0);
}

void CPocketIrked2View::OnRecall() 
{
	OnGameRecall();
}

void CPocketIrked2View::OnGameRecall() 
{
	CPocketIrked2Doc *pDoc=GetDocument();
	
	pDoc->Push();
	m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_ENABLED);
	if(pDoc->Recall())
		OnUpdate(0,0,0);
	else
	{
		pDoc->Pop();
		if(!pDoc->m_llUndoStack.GetCount())
			m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_INDETERMINATE);
	}
}

void CPocketIrked2View::OnRestart() 
{
	OnGameReplaycurrentlevel();	
}

void CPocketIrked2View::OnGameReplaycurrentlevel() 
{
	CPocketIrked2Doc* pDoc=GetDocument();
	pDoc->PlayLevel(pDoc->m_iCurrentLevel);
	OnUpdate(0,0,0);
}

void CPocketIrked2View::OnUndo() 
{
	OnGameUndo();
}

void CPocketIrked2View::OnGameUndo() 
{
	CPocketIrked2Doc* pDoc=GetDocument();
	pDoc->Pop();
	if(!pDoc->m_llUndoStack.GetCount())
		m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_INDETERMINATE);

	OnUpdate(0,0,0);
	
}


void CPocketIrked2View::OnLevelBlocksremaining() 
{
	CBlockRemainingDlg	BlockRemainingDlg;
	CPocketIrked2Doc *pDoc=GetDocument();

	BlockRemainingDlg.m_pBitmaps = m_bmpBricks;
	BlockRemainingDlg.m_pLevel = &pDoc->m_lPlayGround;
	BlockRemainingDlg.DoModal();
}

void CPocketIrked2View::OnLevelClearsolvedlevels() 
{
	CPocketIrked2Doc *pDoc=GetDocument();
	CPocketIrked2App *pApp=(CPocketIrked2App*)AfxGetApp();

	pDoc->m_iMaxLevel=0;
	pDoc->m_iLevelScore=0;
	pApp->WriteProfileInt(pDoc->m_strPack,_T("maxlevel"),0);

	OnLevelFirst();
}

void CPocketIrked2View::OnFirst() 
{
	OnLevelFirst();
}

void CPocketIrked2View::OnLevelFirst() 
{
	CPocketIrked2Doc* pDoc = GetDocument();
	// if already at the first level, do nothing
	if(pDoc->m_iCurrentLevel)
	{
		pDoc->PlayLevel(0);

		if(pDoc->m_iCurrentLevel == pDoc->m_iMaxLevel)
		{
			m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_INDETERMINATE);
			m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_INDETERMINATE);
		}
		else
		{
			m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_ENABLED);
			m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_ENABLED);
		}
		if(!pDoc->m_iCurrentLevel)
		{
			m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_INDETERMINATE);
			m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_INDETERMINATE);
		}
		else
		{
			m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_ENABLED);
			m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_ENABLED);
		}

		if(!pDoc->m_llUndoStack.GetCount())
			m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_INDETERMINATE);
		else
			m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_ENABLED);
		
		m_tbSecondBar.SetState(ID_GAME_RECALL,TBSTATE_INDETERMINATE);
		OnUpdate(0,0,0);
	}
}

void CPocketIrked2View::OnLast() 
{
	OnLevelLast();
}

void CPocketIrked2View::OnLevelLast() 
{
	CPocketIrked2Doc* pDoc = GetDocument();
	pDoc->PlayLevel(pDoc->m_iMaxLevel);

	if(pDoc->m_iCurrentLevel == pDoc->m_iMaxLevel)
	{
		m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_INDETERMINATE);
		m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_INDETERMINATE);
	}
	else
	{
		m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_ENABLED);
		m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_ENABLED);
	}
	if(!pDoc->m_iCurrentLevel)
	{
		m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_INDETERMINATE);
		m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_INDETERMINATE);
	}
	else
	{
		m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_ENABLED);
		m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_ENABLED);
	}

	if(!pDoc->m_iMaxLevel)
	{
		m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_INDETERMINATE);
		m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_INDETERMINATE);
	}
	else
	{
		m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_ENABLED);
		m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_ENABLED);
	}

	if(!pDoc->m_llUndoStack.GetCount())
		m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_INDETERMINATE);
	else
		m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_ENABLED);

	m_tbSecondBar.SetState(ID_GAME_RECALL,TBSTATE_INDETERMINATE);
	OnUpdate(0,0,0);
}

void CPocketIrked2View::OnLevelLevelpacks() 
{
	CPocketIrked2App* pApp = (CPocketIrked2App*)AfxGetApp();
	CPocketIrked2Doc* pDoc = GetDocument();
	CLevelPacksDlg LevelPacksDlg;
	int iRet;

	iRet=LevelPacksDlg.DoModal();
	if(iRet == IDOK) 
	{					 
		if(LevelPacksDlg.m_strLevelSelected.GetLength())
		{
			int iLevel;	    

			pDoc->m_strPack=LevelPacksDlg.m_strLevelSelected+TEXT(".lvl");
			pApp->WriteProfileString(_T("global"),_T("pack"),pDoc->m_strPack);
			iLevel=pApp->GetProfileInt(pDoc->m_strPack,_T("maxlevel"),0);

			pDoc->LoadLevels(pDoc->m_strPack);
			pDoc->PlayLevel(iLevel);
			pDoc->m_iMaxLevel=iLevel;

			if(pDoc->m_iCurrentLevel == pDoc->m_iMaxLevel)
			{
				m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_INDETERMINATE);
				m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_INDETERMINATE);
			}
			else
			{
				m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_ENABLED);
				m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_ENABLED);
			}
			if(!pDoc->m_iCurrentLevel)
			{
				m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_INDETERMINATE);
				m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_INDETERMINATE);
			}
			else
			{
				m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_ENABLED);
				m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_ENABLED);
			}

			m_tbSecondBar.SetState(ID_GAME_RECALL,TBSTATE_INDETERMINATE);
			OnUpdate(0,0,0);
		}
	}
	
}

void CPocketIrked2View::OnLookup() 
{
	OnLevelLookup();
}

void CPocketIrked2View::OnLevelLookup() 
{
	CPocketIrked2Doc* pDoc = GetDocument();
	CLookupDlg dlg;
	/***
	pop up a dialog with the levels listed in numeric order
	along with their names, only completed levels should be listed. ???

  Also display the pack data, author, url, description

  Not so sure I want to display that info on the play screen, except maybe the pack name
	***/
	dlg.pDoc=pDoc;
	if(IDOK == dlg.DoModal())
	{
		pDoc->PlayLevel(dlg.m_iSelected);

		if(pDoc->m_iCurrentLevel == pDoc->m_iMaxLevel)
		{
			m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_INDETERMINATE);
			m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_INDETERMINATE);
		}
		else
		{
			m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_ENABLED);
			m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_ENABLED);
		}
		if(!pDoc->m_iCurrentLevel)
		{
			m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_INDETERMINATE);
			m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_INDETERMINATE);
		}
		else
		{
			m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_ENABLED);
			m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_ENABLED);
		}

		m_tbSecondBar.SetState(ID_GAME_RECALL,TBSTATE_INDETERMINATE);
		m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_INDETERMINATE);
		OnUpdate(0,0,0);
	}
}	

void CPocketIrked2View::OnNext() 
{
	OnLevelNext();
}

void CPocketIrked2View::OnLevelNext() 
{
	CPocketIrked2Doc* pDoc = GetDocument();
	if(pDoc->m_iCurrentLevel < pDoc->m_iMaxLevel)
	{
		pDoc->PlayLevel(pDoc->m_iCurrentLevel+1);

		if(pDoc->m_iCurrentLevel == pDoc->m_iMaxLevel)
		{
			m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_INDETERMINATE);
			m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_INDETERMINATE);
		}
		else
		{
			m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_ENABLED);
			m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_ENABLED);
		}
		if(!pDoc->m_iCurrentLevel)
		{
			m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_INDETERMINATE);
			m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_INDETERMINATE);
		}
		else
		{
			m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_ENABLED);
			m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_ENABLED);
		}
		
		m_tbSecondBar.SetState(ID_GAME_RECALL,TBSTATE_INDETERMINATE);

		if(!pDoc->m_llUndoStack.GetCount())
			m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_INDETERMINATE);
		else
			m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_ENABLED);

	}
	OnUpdate(0,0,0);
}

void CPocketIrked2View::OnBack() 
{
	OnLevelPrevious();
}

void CPocketIrked2View::OnLevelPrevious() 
{
	CPocketIrked2Doc* pDoc = GetDocument();

	// if there is no previous level, do nothing
	if(pDoc->m_iCurrentLevel)
	{
		pDoc->PlayLevel(pDoc->m_iCurrentLevel-1);

		if(pDoc->m_iCurrentLevel == pDoc->m_iMaxLevel)
		{
			m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_INDETERMINATE);
			m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_INDETERMINATE);
		}
		else
		{
			m_tbSecondBar.SetState(ID_LEVEL_LAST,TBSTATE_ENABLED);
			m_tbSecondBar.SetState(ID_LEVEL_NEXT,TBSTATE_ENABLED);
		}
		if(!pDoc->m_iCurrentLevel)
		{
			m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_INDETERMINATE);
			m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_INDETERMINATE);
		}
		else
		{
			m_tbSecondBar.SetState(ID_LEVEL_FIRST,TBSTATE_ENABLED);
			m_tbSecondBar.SetState(ID_LEVEL_PREVIOUS,TBSTATE_ENABLED);
		}
		
		if(!pDoc->m_llUndoStack.GetCount())
			m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_INDETERMINATE);
		else
			m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_ENABLED);

		m_tbSecondBar.SetState(ID_GAME_RECALL,TBSTATE_INDETERMINATE);
		OnUpdate(0,0,0);
	}
}

void CPocketIrked2View::OnLevelShowsolution() 
{
	CAreYouSureDlg dlg;
	int TotalMoves, MoveNum;
	char chI, chJ; 
	int i, j, i2;//, j2;
	BOOL direction;
#define Left (TRUE)
#define Right (FALSE)

	if(IDOK == dlg.DoModal())
	{
		CPocketIrked2Doc* pDoc = GetDocument();

		OnRestart();
		pDoc->m_iLevelScore+=strlen((char*)pDoc->m_lPlayGround.m_btSolution);
		if(pDoc->m_lPlayGround.m_btSolution[0])
		{
			TotalMoves=strlen((char*)pDoc->m_lPlayGround.m_btSolution)/2;

			for(MoveNum=0;MoveNum < TotalMoves;MoveNum++)
			{
	/***/

		// the question is should this play in the normal window or pop up a solutions
		// window. I'm thinking that 5pts should be added for each hint
		// must start with a fresh board.

				chI = pDoc->m_lPlayGround.m_btSolution[MoveNum * 2];
				chJ = pDoc->m_lPlayGround.m_btSolution[MoveNum * 2 + 1];
   
				i = chI - 'a';
				if (chI <= 'Z') 
				{
					direction = Left;
					i = chI - 'A';
				}
				j = chJ - 'a';
				if (chJ <= 'Z') 
				{
					direction = Right;
					j = chJ - 'A';
				}

				if(direction == Right)
				{
					i2=i+1;
				}
				else
				{
					i2=i-1;
				}

				// Check for validity

				if (j < 0 || j >= 8 || i < 0 || i >= 10) 
				{
					return;
				}

		//These should be translated to MouseDown and MouseUp calls

				OnLButtonDown(0,CPoint(16+(i*16)+8,16+(j*16)+8));
				OnLButtonUp(0,CPoint(16+(i2*16)+8,16+(j*16)+8)); // there is no j2 because you can't move down
  
	/***/
			}
		}
	}
}



void CPocketIrked2View::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CRect rcBase, rcBrick;
	int i,j;
	CPocketIrked2Doc* pDoc = GetDocument();

	GetWindowRect(rcBase);

	for(i=0;i<10;i++)
		for(j=0;j<8;j++)
		{
			m_sBricks[i][j].GetWindowRect(rcBrick);
			//rcBrick.OffsetRect(-rcBase.left,-rcBase.top);
			if(rcBrick.PtInRect(point))
			{
				if(pDoc->m_lPlayGround.m_lBits[j][i] && pDoc->m_lPlayGround.m_lBits[j][i] < 9)
				{
					m_iDnI=i;
					m_iDnJ=j;
				}
				else
				{
					m_iDnI=-1;
					m_iDnJ=-1;
				}
			}
		}

//	CView::OnLButtonDown(nFlags, point);
}

// if the up requests a multi space move then what we do is is queue the moves, if the top move in the queue fails then the queue is deleted
void CPocketIrked2View::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CRect rcBase, rcBrick;
	BYTE mark[8][10];
	BOOL moved;
	CPocketIrked2Doc* pDoc=GetDocument();
	CPocketIrked2App* pApp=(CPocketIrked2App*)AfxGetApp();

	int i,j, iUpI, iUpJ;

	if(m_iDnJ == -1)
		return;

	GetWindowRect(rcBase);

	BOOL bPushed=FALSE;

	for(i=0;i<10;i++)
	{
		for(j=0;j<8;j++)
		{
			m_sBricks[i][j].GetWindowRect(rcBrick);
			//rcBrick.OffsetRect(-rcBase.left,-rcBase.top);
			if(rcBrick.PtInRect(point))
			{
				iUpI=i;
				iUpJ=j;

				if(iUpJ>9 || iUpI>8 || iUpJ<0 || iUpI<0)
					return;

				/***
				CString strMsg;
				strMsg.Format(TEXT("%d,%d->%d,%d"),m_iDnI,m_iDnJ,iUpI,iUpJ);
				MessageBox(strMsg);
				***/

			// if a block was moved to the left or right
			if((iUpJ == m_iDnJ) && ((iUpI == m_iDnI+1) || (iUpI == m_iDnI-1)))
			{
				if(pDoc->m_lPlayGround.m_lBits[iUpJ][iUpI] == 0)
				{
					if(!bPushed)
					{
						bPushed=TRUE;
						pDoc->Push();
						m_iMoves++;
						m_tbSecondBar.SetState(ID_GAME_UNDO,TBSTATE_ENABLED);

					}
					// move block
					pDoc->m_lPlayGround.m_lBits[iUpJ][iUpI] = pDoc->m_lPlayGround.m_lBits[m_iDnJ][m_iDnI];
					pDoc->m_lPlayGround.m_lBits[m_iDnJ][m_iDnI]=0;
					OnUpdate(0,0,0);
				}
			
			// fall blocks
				
				do
				{
					do
					{
						moved=FALSE;
						for(i=0;i<10;i++)
						{
							for(j=6;j>=0;j--)
							{
								if((pDoc->m_lPlayGround.m_lBits[j][i] != 9) && (pDoc->m_lPlayGround.m_lBits[j][i] != 0) && pDoc->m_lPlayGround.m_lBits[j+1][i] == 0)
								{
									pDoc->m_lPlayGround.m_lBits[j+1][i]=pDoc->m_lPlayGround.m_lBits[j][i];
									pDoc->m_lPlayGround.m_lBits[j][i]=0;
									moved=TRUE;
									OnUpdate(0,0,0);
								}
							}
						}
					}while(moved);

					// knock out blocks

					// This SEGMENT taken directly from VEXED 
					// James McCombe
					// cybertube@earthling.net
					// http://spacetube.tsx.org

					// just go through from top to bottom marking pieces which have matches above, below, left and to the right of them
					for (j = 0; j<8; j++)
					{
						for (i = 0; i<10; i++)
						{
							mark[j][i] = 0; // ALWAYS initialise each element in the 'mark' array
							if (!((pDoc->m_lPlayGround.m_lBits[j][i] == 0) || (pDoc->m_lPlayGround.m_lBits[j][i] == 9))) // only check if its not air or a wall block
							{
								mark[j][i] |= (pDoc->m_lPlayGround.m_lBits[j - 1][i] == pDoc->m_lPlayGround.m_lBits[j][i]); // if there is an identical piece above then mark this piece
								mark[j][i] |= (pDoc->m_lPlayGround.m_lBits[j + 1][i] == pDoc->m_lPlayGround.m_lBits[j][i]); // if there is an identical piece below then mark this piece
								mark[j][i] |= (pDoc->m_lPlayGround.m_lBits[j][i + 1] == pDoc->m_lPlayGround.m_lBits[j][i]); // if there is an identical piece to the right then mark this piece
								mark[j][i] |= (pDoc->m_lPlayGround.m_lBits[j][i - 1] == pDoc->m_lPlayGround.m_lBits[j][i]); // if there is an identical piece to the left then mark this piece
							}
						}
					}
					// END SEGMENT
			

					// go through the current level array checking if a piece is marked and if so, remove it
					for (j = 0; j <= 7; j ++)
						for (i = 0; i <= 9; i ++)
							if (mark[j][i])
							{
								pDoc->m_lPlayGround.m_lBits[j][i]=0;
								OnUpdate(0,0,0);
								moved=TRUE;
							}
					}while(moved);
				}
			}
		}
	}

	if(!m_iCount)
	{
		// do scoring;
		/***
		I'm not sure how scoring should persist, Is the score global?
		per pack?  Are there players?
		
		scoring will persist for each pack, until it is cleared
		
		
		  score += moves - par
		***/

		// only score if this is for advancement
		if(pDoc->m_iCurrentLevel == pDoc->m_iMaxLevel)
		{
			pDoc->m_iLevelScore+=(m_iMoves-(strlen((char*)(pDoc->m_lPlayGround.m_btSolution))/2));
			CString str;
			str.Format(_T("Par: %d   Score: %d"),strlen((char*)(pDoc->m_lPlayGround.m_btSolution))/2, pDoc->m_iLevelScore);
			m_sAuthor.SetWindowText(str);

			pApp->WriteProfileInt(pDoc->m_strPack,CString("score"),pDoc->m_iLevelScore);
		}

		if(pDoc->m_iCurrentLevel == pDoc->m_iMaxLevel)
		{
			if(pDoc->m_iMaxLevel < pDoc->m_iMaxPackLevel)
			{
				pDoc->m_iMaxLevel++;
				pApp->WriteProfileInt(pDoc->m_strPack,_T("maxlevel"),pDoc->m_iMaxLevel);
			}
		}

		m_iMoves=0;
		OnLevelNext();
	}
//	CView::OnLButtonUp(nFlags, point);
}



void CPocketIrked2View::OnUpdateGameUndo(CCmdUI* pCmdUI) 
{
	// this controles menu items only
	if(TBSTATE_ENABLED == m_tbSecondBar.GetState(ID_GAME_UNDO))
		pCmdUI->Enable();
	else
		pCmdUI->Enable(FALSE);
}

void CPocketIrked2View::OnUpdateGameMemory(CCmdUI* pCmdUI) 
{
	// this controles menu items only
	if(TBSTATE_ENABLED == m_tbSecondBar.GetState(ID_GAME_MEMORY))
		pCmdUI->Enable();
	else
		pCmdUI->Enable(FALSE);
}

void CPocketIrked2View::OnUpdateGameRecall(CCmdUI* pCmdUI) 
{
	// this controles menu items only
	if(TBSTATE_ENABLED == m_tbSecondBar.GetState(ID_GAME_RECALL))
		pCmdUI->Enable();
	else
		pCmdUI->Enable(FALSE);
}

void CPocketIrked2View::OnUpdateLevelFirst(CCmdUI* pCmdUI) 
{
	// this controles menu items only
	if(TBSTATE_ENABLED == m_tbSecondBar.GetState(ID_LEVEL_FIRST))
		pCmdUI->Enable();
	else
		pCmdUI->Enable(FALSE);
}

void CPocketIrked2View::OnUpdateLevelLast(CCmdUI* pCmdUI) 
{
	// this controles menu items only
	if(TBSTATE_ENABLED == m_tbSecondBar.GetState(ID_LEVEL_LAST))
		pCmdUI->Enable();
	else
		pCmdUI->Enable(FALSE);
}

void CPocketIrked2View::OnUpdateLevelNext(CCmdUI* pCmdUI) 
{
	// this controles menu items only
	if(TBSTATE_ENABLED == m_tbSecondBar.GetState(ID_LEVEL_NEXT))
		pCmdUI->Enable();
	else
		pCmdUI->Enable(FALSE);
}

void CPocketIrked2View::OnUpdateLevelPrevious(CCmdUI* pCmdUI) 
{
	// this controles menu items only
	if(TBSTATE_ENABLED == m_tbSecondBar.GetState(ID_LEVEL_PREVIOUS))
		pCmdUI->Enable();
	else
		pCmdUI->Enable(FALSE);
}

void CPocketIrked2View::OnUpdateLevelShowsolution(CCmdUI* pCmdUI) 
{
	CPocketIrked2Doc *pDoc = GetDocument();

	// this controles menu items only
	if(strlen((char*)(pDoc->m_lPlayGround.m_btSolution)))
		pCmdUI->Enable();
	else
		pCmdUI->Enable(FALSE);
}

LRESULT CPocketIrked2View::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{

	if(message == WM_CTLCOLORSTATIC)
	{
		HDC hdc = (HDC)wParam;
		HWND hwnd = (HWND)lParam;
		HBRUSH hbr;

		SetBkMode(hdc,TRANSPARENT);
		hbr = CreateSolidBrush(RGB(250,250,250));
		return (LRESULT)hbr;
	}
	else
		return CView::WindowProc(message, wParam, lParam);
}

BOOL CPocketIrked2View::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	
	return TRUE; //CView::OnEraseBkgnd(pDC);
}

void CPocketIrked2View::DrawBricks(CDC* pDC) 
{
	if(!m_bInit)
		return;

	for(int i=0;i<10;i++)
	{
		for(int j=0;j<8;j++)
		{
			CDC* pBitmapDC = new CDC();

			pBitmapDC -> CreateCompatibleDC(pDC);
			CBitmap * pOldBmp = pBitmapDC ->SelectObject(&m_bmpBricks[m_sBricks[i][j].m_iBitmap]);
				
			pDC ->BitBlt(m_sBricks[i][j].m_pt.x,m_sBricks[i][j].m_pt.y,16,16,pBitmapDC,0,0,SRCCOPY);

			pBitmapDC -> SelectObject(pOldBmp);

			delete pBitmapDC;
		}
	}
}